var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/error-catcher.tsx
var error_catcher_exports = {};
__export(error_catcher_exports, {
  default: () => ErrorCatcher
});
module.exports = __toCommonJS(error_catcher_exports);
var React = __toESM(require("react"));
var import_jsx_runtime = require("react/jsx-runtime");
var _ErrorCatcher = class _ErrorCatcher extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      hasError: false,
      componentStack: "",
      error: null
    };
  }
  static getDerivedStateFromError(error) {
    return {
      hasError: true
    };
  }
  componentDidCatch(error, errorInfo) {
    const { componentStack } = errorInfo;
    this.setState({
      error,
      componentStack
    });
  }
  render() {
    var _a, _b, _c, _d, _e, _f;
    if (this.state.hasError) {
      return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(
        "div",
        {
          style: {
            padding: "5px"
          },
          children: [
            /* @__PURE__ */ (0, import_jsx_runtime.jsx)("h5", { children: "Error caught in React Components" }),
            ((_a = this.state.error) == null ? void 0 : _a.name) && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("h5", { children: [
              "Error Name: ",
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("code", { children: (_b = this.state.error) == null ? void 0 : _b.name })
            ] }),
            ((_c = this.state.error) == null ? void 0 : _c.message) && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)("h5", { children: [
              "Message:",
              (_d = this.state.error) == null ? void 0 : _d.message
            ] }),
            this.state.componentStack && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("h6", { children: "Component Stack:" }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("pre", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("code", { children: this.state.componentStack }) }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("br", {})
            ] }),
            ((_e = this.state.error) == null ? void 0 : _e.stack) && /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(import_jsx_runtime.Fragment, { children: [
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("h6", { children: "Error Stack:" }),
              /* @__PURE__ */ (0, import_jsx_runtime.jsx)("pre", { children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)("code", { children: (_f = this.state.error) == null ? void 0 : _f.stack }) })
            ] })
          ]
        }
      );
    }
    return this.props.children;
  }
};
__name(_ErrorCatcher, "ErrorCatcher");
var ErrorCatcher = _ErrorCatcher;
//# sourceMappingURL=error-catcher.js.map