var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  KnapsackReactRenderer: () => KnapsackReactRenderer
});
module.exports = __toCommonJS(src_exports);

// src/renderer-react.ts
var import_sleep_promise = __toESM(require("sleep-promise"));
var import_renderer_webpack_base = require("@knapsack/renderer-webpack-base");
var import_utils3 = require("@knapsack/utils");
var import_app2 = require("@knapsack/app");
var import_types2 = require("@knapsack/types");
var import_file_utils3 = require("@knapsack/file-utils");
var import_path2 = require("path");

// src/utils.ts
var import_app = require("@knapsack/app");
var import_file_utils = require("@knapsack/file-utils");
var import_utils = require("@knapsack/utils");
var import_format = require("@knapsack/file-utils/format");
var import_path = __toESM(require("path"));
var import_types = require("@knapsack/types");
function renderUsageTemplate({
  templateName,
  attributes,
  children
}) {
  return `
    <${templateName}
      ${attributes}
      ${children ? `>
        ${children}
      </${templateName}>` : "/>"}
  `;
}
__name(renderUsageTemplate, "renderUsageTemplate");
function renderDemoAppTemplate({
  imports,
  children
}) {
  return `${imports}

function DemoApp() {
  return (
    <div className="demo-app knapsack-pattern-direct-parent">
      ${children}
    </div>
  )
}
`;
}
__name(renderDemoAppTemplate, "renderDemoAppTemplate");
async function getUsage(data) {
  const props = Object.keys(data.props || {}).map((key) => {
    const value = data.props[key];
    return {
      key,
      value
    };
  });
  const { templateName, children, extraProps = [] } = data;
  if (!templateName) {
    throw new Error(
      `Cannot getUsage of a React Component when no "templateName" is provided.`
    );
  }
  const attributes = props.map(({ key, value }) => {
    switch (typeof value) {
      case "string":
        if (value.startsWith("(") && value.includes("=>")) {
          return `${key}={${value}}`;
        }
        return `${key}="${value}"`;
      case "boolean":
        return value ? `${key}` : `${key}={${value}}`;
      default:
        return `${key}={${JSON.stringify(value)}}`;
    }
  });
  const extraAttributes = [];
  const slotProps = {};
  extraProps.forEach(({ key, value }) => {
    var _a;
    slotProps[key] = (_a = slotProps[key]) != null ? _a : [];
    slotProps[key].push(value);
  });
  Object.entries(slotProps).forEach(([key, values]) => {
    const value = values.length === 1 ? values[0] : `<>${values.join("\n")}</>`;
    extraAttributes.push(`${key}={${value}}`);
  });
  const result = renderUsageTemplate({
    templateName,
    attributes: [...attributes, ...extraAttributes].join(" "),
    children
  });
  return data.format ? (0, import_format.formatCode)({
    contents: result,
    path: "x.tsx"
    // doing this to set format language
  }).then((code) => code.trim()).catch(() => result.trim()) : result.trim();
}
__name(getUsage, "getUsage");
async function getDemoAppUsage({
  children,
  imports
}) {
  const code = renderDemoAppTemplate({
    children,
    imports
  });
  return (0, import_format.formatCode)({
    contents: code,
    path: "x.tsx"
    // doing this to set format language
  });
}
__name(getDemoAppUsage, "getDemoAppUsage");
var reactTypeScriptDocsCache = /* @__PURE__ */ new Map();
var clearReactTypeScriptDocsCache = /* @__PURE__ */ __name(() => {
  import_app.log.verbose(`Clearing React TypeScript inferSpec cache...`);
  reactTypeScriptDocsCache.clear();
}, "clearReactTypeScriptDocsCache");
async function getReactTypeScriptDocs({
  src,
  exportName
}) {
  const tsConfigPath = import_path.default.resolve(process.cwd(), "./tsconfig.json");
  const tsConfigExists = await (0, import_file_utils.exists)(tsConfigPath);
  const rdTs = await import("react-docgen-typescript");
  try {
    const config = {
      shouldExtractLiteralValuesFromEnum: true,
      savePropValueAsString: true,
      skipChildrenPropWithoutDoc: false,
      // In addition to the ones listed here, which had not strangely included these below ~ https://github.com/styleguidist/react-docgen-typescript/blob/287e7012843cb26fed8f4bd8ee24e462c25a1414/src/parser.ts#L308
      customComponentTypes: ["VoidFunctionComponent", "VFC"]
    };
    const parse2 = tsConfigExists ? rdTs.withCustomConfig(tsConfigPath, config).parse : rdTs.withDefaultConfig(config).parse;
    const results = reactTypeScriptDocsCache.get(src) || parse2(src);
    if (!reactTypeScriptDocsCache.has(src)) {
      reactTypeScriptDocsCache.set(src, results);
    }
    if (!results)
      return false;
    const spec = {
      props: {
        $schema: "http://json-schema.org/draft-07/schema",
        type: "object",
        required: [],
        properties: {}
      },
      slots: {
        // children: {
        //   title: 'children',
        // },
      }
    };
    const isDefaultExport = !exportName || exportName === "default";
    const result = isDefaultExport ? results.pop() : results.find((r) => r.displayName === exportName);
    if (!result)
      return false;
    const { displayName } = result;
    Object.entries((result == null ? void 0 : result.props) || {}).forEach(([propName, propDef]) => {
      var _a, _b, _c, _d, _e;
      const { name, description, defaultValue, required, type, parent } = propDef;
      const propType = (_a = type == null ? void 0 : type.name) == null ? void 0 : _a.replace("| undefined", "").replace(/<.*/g, "").trim();
      switch (propType) {
        case "string":
          spec.props.properties[propName] = {
            type: "string"
          };
          break;
        case "number":
          spec.props.properties[propName] = {
            type: "number"
          };
          break;
        case "boolean":
        case "bool":
          if (defaultValue && "value" in defaultValue) {
            defaultValue.value = defaultValue.value === "true";
          }
          spec.props.properties[propName] = {
            type: "boolean"
          };
          break;
        case "enum":
          spec.props.properties[propName] = {
            type: "string",
            // yes there is a double "value" & yes it is confusing
            enum: [
              // ensure list is unique
              ...new Set(
                type.value.map(({ value }) => (0, import_utils.removeWrappingDoubleQuotes)(value == null ? void 0 : value.trim())).filter(Boolean)
              )
            ]
          };
          break;
        case "ReactNode":
        case "React.ReactNode":
          spec.slots[propName] = {
            title: propName
          };
          if (description) {
            spec.slots[propName] = {
              ...spec.slots[propName],
              description
            };
          }
          break;
        case "VFC":
        case "FC":
          spec.slots[propName] = {
            title: propName,
            description: description || "A reference to a component",
            isTemplateReference: true,
            allowOnlyOne: true,
            disallowText: true
          };
          break;
        default: {
          if ((_b = type == null ? void 0 : type.name) == null ? void 0 : _b.startsWith("(")) {
            spec.props.properties[propName] = {
              // description: `\`${type.name}\` ${description}`,
              typeof: "function",
              tsType: (_c = propDef == null ? void 0 : propDef.type) == null ? void 0 : _c.name
            };
          } else if ((_d = type == null ? void 0 : type.name) == null ? void 0 : _d.includes("|")) {
            const options = type.name.split("|").map((enumItem) => (0, import_utils.removeWrappingDoubleQuotes)(enumItem.trim())).filter(Boolean);
            if (options == null ? void 0 : options.length) {
              spec.props.properties[propName] = {
                type: "string",
                // ensuring list is unique
                enum: [...new Set(options)]
              };
            }
          } else {
            spec.props.properties[propName] = {
              tsType: (_e = propDef == null ? void 0 : propDef.type) == null ? void 0 : _e.name
            };
          }
        }
      }
      if (spec.props.properties[propName]) {
        if (required)
          spec.props.required.push(propName);
        if (description && !spec.props.properties[propName].description) {
          spec.props.properties[propName].description = description;
        }
        if (defaultValue && "value" in defaultValue) {
          if ((0, import_types.isNumberProp)(spec.props.properties[propName])) {
            spec.props.properties[propName].default = parseFloat(
              defaultValue.value
            );
          } else {
            spec.props.properties[propName].default = (0, import_utils.removeWrappingDoubleQuotes)(defaultValue.value);
          }
        }
      }
    });
    return spec;
  } catch (error) {
    import_app.log.warn(
      "Could not infer spec from React TypeScript file",
      {
        src,
        exportName,
        error
      },
      "react renderer"
    );
    return {};
  }
}
__name(getReactTypeScriptDocs, "getReactTypeScriptDocs");
async function getReactPropTypesDocs({
  src,
  exportName
}) {
  const reactDocs = await import("react-docgen");
  try {
    const { builtinResolvers } = reactDocs;
    const fileSrc = await (0, import_file_utils.readFile)(src);
    const { FindExportedDefinitionsResolver } = builtinResolvers;
    const results = reactDocs.parse(fileSrc, {
      resolver: new FindExportedDefinitionsResolver(),
      handlers: null,
      filename: src
      // babelrc: false,
    });
    const isDefaultExport = !exportName || exportName === "default";
    const result = isDefaultExport ? results.pop() : results.find((r) => r.displayName === exportName);
    const spec = {
      isInferred: true,
      props: {
        $schema: "http://json-schema.org/draft-07/schema",
        type: "object",
        required: [],
        properties: {}
      },
      slots: {}
    };
    Object.entries((result == null ? void 0 : result.props) || {}).forEach(([propName, propDef]) => {
      var _a;
      const { required, description, defaultValue } = propDef;
      switch ((_a = propDef == null ? void 0 : propDef.type) == null ? void 0 : _a.name) {
        case "string":
          spec.props.properties[propName] = {
            type: "string"
          };
          break;
        case "func":
          spec.props.properties[propName] = {
            type: "string"
          };
          break;
        case "bool":
          spec.props.properties[propName] = {
            type: "boolean"
          };
          break;
        case "node":
          spec.slots[propName] = {
            title: propName,
            description
          };
      }
      if (spec.props.properties[propName]) {
        if (required)
          spec.props.required.push(propName);
        if (description && !spec.props.properties[propName].description) {
          spec.props.properties[propName].description = description;
        }
        if (defaultValue && "value" in defaultValue) {
          spec.props.properties[propName].default = typeof defaultValue.value === "string" ? (0, import_utils.removeWrappingDoubleQuotes)(defaultValue.value) : defaultValue.value;
        }
      }
    });
    return spec;
  } catch (error) {
    import_app.log.warn(
      "Could not infer spec from React PropTypes",
      {
        src,
        exportName,
        error
      },
      "react renderer"
    );
    return false;
  }
}
__name(getReactPropTypesDocs, "getReactPropTypesDocs");
function cleanUpSpec({
  spec
}) {
  var _a;
  if (spec === false)
    return spec;
  Object.entries(((_a = spec.props) == null ? void 0 : _a.properties) || {}).forEach(([propName, prop]) => {
    if ((0, import_types.isOptionsProp)(prop)) {
      if (!prop.enum.includes(prop.default)) {
        prop.default = void 0;
      }
    }
  });
  return spec;
}
__name(cleanUpSpec, "cleanUpSpec");
async function getReactSpec({
  src,
  exportName
}) {
  const { ext } = import_path.default.parse(src);
  switch (ext) {
    case ".mjs":
    case ".js": {
      const typeDefPath = src.replace(ext, ".d.ts");
      if ((0, import_file_utils.existsSync)(typeDefPath)) {
        const typeDefSpec = await getReactTypeScriptDocs({
          src: typeDefPath,
          exportName
        });
        if (typeDefSpec) {
          return typeDefSpec;
        }
      }
      const pkg2 = (0, import_file_utils.findUpPkgJson)(import_path.default.dirname(src));
      if (pkg2.exists) {
        const typeKeys = ["types", "typings"];
        for (const typeKey of typeKeys) {
          const typeKeyValue = pkg2.pkg[typeKey];
          if (!typeKeyValue)
            continue;
          const otherTypeDefPath = import_path.default.join(pkg2.pkgDir, typeKeyValue);
          if ((0, import_file_utils.existsSync)(otherTypeDefPath)) {
            const typeDefSpec = await getReactTypeScriptDocs({
              src: otherTypeDefPath,
              exportName
            });
            if (typeDefSpec) {
              return typeDefSpec;
            }
          }
        }
      }
      return getReactPropTypesDocs({ src, exportName });
    }
    case ".jsx": {
      return getReactPropTypesDocs({ src, exportName });
    }
    case ".ts":
    case ".tsx": {
      return getReactTypeScriptDocs({ src, exportName });
    }
  }
}
__name(getReactSpec, "getReactSpec");
async function getReactDocs(opt) {
  return cleanUpSpec({
    spec: await getReactSpec(opt)
  });
}
__name(getReactDocs, "getReactDocs");
async function copyReactAssets(distDirAbsolute, publicPath) {
  try {
    const { version: reactVersion } = (0, import_file_utils.getModulePkgJson)("react");
    const { version: reactDomVersion } = (0, import_file_utils.getModulePkgJson)("react-dom");
    const reactRoot = import_path.default.dirname(
      require.resolve("react", {
        paths: [process.cwd()]
      })
    );
    const reactDomRoot = import_path.default.dirname(
      require.resolve("react-dom", {
        paths: [process.cwd()]
      })
    );
    await Promise.all([
      (0, import_file_utils.copy)(
        import_path.default.join(reactRoot, "umd/react.development.js"),
        import_path.default.join(distDirAbsolute, `react.development.${reactVersion}.js`)
      ),
      (0, import_file_utils.copy)(
        import_path.default.join(reactRoot, "umd/react.production.min.js"),
        import_path.default.join(distDirAbsolute, `react.production.min.${reactVersion}.js`)
      ),
      (0, import_file_utils.copy)(
        import_path.default.join(reactDomRoot, "umd/react-dom.production.min.js"),
        import_path.default.join(
          distDirAbsolute,
          `react-dom.production.min.${reactDomVersion}.js`
        )
      ),
      (0, import_file_utils.copy)(
        import_path.default.join(reactDomRoot, "umd/react-dom.development.js"),
        import_path.default.join(
          distDirAbsolute,
          `react-dom.development.${reactDomVersion}.js`
        )
      )
    ]);
    const reactFileSuffix = process.env.NODE_ENV === "production" ? "production.min" : "development";
    return [
      import_path.default.join(publicPath, `react.${reactFileSuffix}.${reactVersion}.js`),
      import_path.default.join(
        publicPath,
        `react-dom.${reactFileSuffix}.${reactDomVersion}.js`
      )
    ];
  } catch (error) {
    import_app.log.warn(
      'Error trying to copy "react" and "react-dom" JS files, are they installed? We want to use your exact versions.',
      error,
      "templateRenderer:react"
    );
    process.exit(1);
  }
}
__name(copyReactAssets, "copyReactAssets");

// src/react-creators.ts
var import_file_utils2 = require("@knapsack/file-utils");
var import_creator_utils = require("@knapsack/creator-utils");
var import_ks_file_utils = require("@knapsack/ks-file-utils");
var import_utils2 = require("@knapsack/utils");
function isCapitalLetter(char) {
  return char.toUpperCase() === char;
}
__name(isCapitalLetter, "isCapitalLetter");
function startsWithCapitalLetter(str) {
  return isCapitalLetter(str[0]);
}
__name(startsWithCapitalLetter, "startsWithCapitalLetter");
function createPatternData({
  importName,
  id,
  title = importName,
  pkgPath,
  initialDemoId
}) {
  return {
    id,
    title,
    description: "",
    statuses: {
      main: "ready"
    },
    templates: [
      {
        id: "react",
        title: "react",
        path: pkgPath,
        alias: importName,
        templateLanguageId: "react",
        spec: {
          isInferred: true
        },
        demoIds: [initialDemoId],
        blockIds: []
      }
    ],
    tabs: [
      {
        type: "template",
        id: "react"
      }
    ],
    subPages: []
  };
}
__name(createPatternData, "createPatternData");
var createReactPattern = (0, import_creator_utils.createCreator)({
  id: "react-patterns",
  title: "React Ks Patterns",
  description: "Adds React templates as Knapsack Patterns",
  getQuestions: async () => ({
    pkgPath: {
      type: "text",
      title: "Package path"
    },
    importPrefix: {
      type: "text",
      title: "Import Prefix to Remove"
    }
  }),
  getTasks: async ({ answers: { pkgPath, importPrefix = "" }, config }) => {
    const dataDir = config.dest;
    const currentPatterns = await (0, import_ks_file_utils.readKsPatternConfigs)({
      dataDir
    });
    const currentReactPatternsImportNames = currentPatterns.reduce(
      (cur, pattern) => {
        var _a, _b;
        const reactTemplates = (_b = (_a = pattern.templates) == null ? void 0 : _a.filter((t) => t.templateLanguageId === "react")) != null ? _b : [];
        cur.push(...reactTemplates.map((t) => t.alias));
        return cur;
      },
      []
    );
    const { exports: allImports } = await (0, import_file_utils2.getJsExportNames)({
      path: pkgPath
    });
    return [
      {
        title: "Pick Imports to add",
        task: (_, task) => import_creator_utils.tasks.runSubCreator({
          task,
          config,
          creator: (0, import_creator_utils.createCreator)({
            id: "react-pattern-import-names",
            getQuestions: async () => ({
              importNames: {
                type: "choices",
                choices: allImports.filter(
                  (importName) => startsWithCapitalLetter(importName) && !currentReactPatternsImportNames.includes(importName)
                ).map((importName) => ({
                  value: importName
                }))
              }
            }),
            getTasks: async ({ answers: { importNames } }) => {
              const patterns = importNames.map((importName) => ({
                importName,
                patternId: importName.startsWith(importPrefix) ? importName.slice(importPrefix.length).toLowerCase() : importName.toLowerCase()
              }));
              return [
                ...patterns.map(
                  ({ importName, patternId }) => ({
                    title: `Add ${importName} React Template`,
                    task: async (__, subTask) => {
                      const initialDemo = {
                        type: "data",
                        id: (0, import_utils2.makeShortId)(),
                        title: "Main",
                        patternId,
                        templateId: "react",
                        data: {
                          props: {},
                          slots: {}
                        }
                      };
                      const pattern = createPatternData({
                        id: patternId,
                        importName,
                        pkgPath,
                        initialDemoId: initialDemo.id
                      });
                      await Promise.all([
                        (0, import_ks_file_utils.writeDemo)({
                          dataDir,
                          demo: initialDemo
                        }),
                        (0, import_ks_file_utils.writeKsPatternConfig)({
                          dataDir,
                          patternId,
                          data: pattern
                        })
                      ]);
                    }
                  })
                ),
                {
                  title: `Updating Nav`,
                  task: async (__, subTask) => {
                    const { byId } = await (0, import_ks_file_utils.readKsNavConfig)({
                      dataDir
                    });
                    const componentsGroup = Object.values(byId).find(
                      ({ path: path2, name, id }) => {
                        if (path2)
                          return false;
                        if (name.toLowerCase() === "patterns")
                          return true;
                        if (name.toLowerCase() === "components")
                          return true;
                        return false;
                      }
                    );
                    await (0, import_ks_file_utils.addKsNavItems)({
                      dataDir,
                      navItems: patterns.map(({ patternId }) => ({
                        navId: patternId,
                        navPath: `/pattern/${patternId}`,
                        navParent: (componentsGroup == null ? void 0 : componentsGroup.id) || "root"
                      }))
                    });
                  }
                }
              ];
            }
          })
        })
      }
    ];
  }
});

// src/renderer-react.ts
var { pkg } = (0, import_file_utils3.findUpPkgJson)(__dirname);
import_app2.log.setupUpdateNotifier({ ...pkg, name: pkg.name, version: pkg.version });
var _KnapsackReactRenderer = class _KnapsackReactRenderer extends import_renderer_webpack_base.KnapsackRendererWebpackBase {
  constructor({
    webpackConfig,
    demoWrapperPath = (0, import_path2.join)(__dirname, "./demo-wrapper.js"),
    id = "react",
    disableReactStrictMode
  } = {}) {
    super({
      id,
      extension: ".jsx",
      language: "jsx",
      webpackConfig
    });
    this.getMeta = /* @__PURE__ */ __name(() => ({
      id: this.id,
      title: "React",
      aliasUse: "optional",
      aliasTitle: "Named Export",
      aliasIsJsNamedExport: true,
      aliasDescription: "If `export X` was used instead of `export default`, then provide X.",
      enableDataDemos: true,
      enableTemplateDemos: true,
      hasSlotsSupport: true,
      version: pkg.version,
      hasInferSpecSupport: true,
      syntaxHighlightingLanguage: "jsx",
      hasTemplateSuggestionsSupport: true
    }), "getMeta");
    this.inferSpec = /* @__PURE__ */ __name(async ({
      template,
      templatePath
    }) => {
      var _a;
      const spec = await getReactDocs({
        src: templatePath,
        exportName: template.alias || "default"
      });
      if (spec !== false) {
        const totalProps = Object.keys(((_a = spec == null ? void 0 : spec.props) == null ? void 0 : _a.properties) || {}).length;
        const totalSlots = Object.keys((spec == null ? void 0 : spec.slots) || {}).length;
        if (totalProps === 0 && totalSlots === 0) {
          return false;
        }
      }
      return spec;
    }, "inferSpec");
    this.getTemplateMeta = /* @__PURE__ */ __name(async ({
      pattern,
      template
    }) => {
      var _a, _b;
      const files = [];
      if ((_a = template == null ? void 0 : template.spec) == null ? void 0 : _a.props) {
        const schema = JSON.parse(JSON.stringify(template.spec.props));
        if ((_b = template == null ? void 0 : template.spec) == null ? void 0 : _b.slots) {
          Object.entries(template.spec.slots).forEach(([id, info]) => {
            var _a2;
            schema.properties[id] = {
              typeof: "function",
              tsType: "React.ReactNode",
              description: info.allowedPatternIds ? `${info.description}. Only use: ${info.allowedPatternIds.join(
                ", "
              )}` : info.description
            };
            schema.required = (_a2 = schema.required) != null ? _a2 : [];
            if (info.isRequired)
              schema.required.push(id);
          });
        }
        const typeDefs = await _KnapsackReactRenderer.convertSchemaToTypeScriptDefs({
          schema,
          title: `${this.changeCase(pattern.id)}Props`,
          // @todo pull in base url
          description: `[Knapsack Docs](http://localhost:3999/pattern/${pattern.id}/${template.id})`,
          patternId: pattern.id,
          templateId: template.id,
          postBanner: `import * as React from 'react';`
        });
        files.push({
          contents: typeDefs,
          encoding: "utf8",
          path: `${pattern.id}.${template.id}.spec.d.ts`
        });
        files.push({
          contents: JSON.stringify(schema, null, "  "),
          encoding: "utf8",
          path: `${pattern.id}.${template.id}.spec.json`
        });
      }
      return files;
    }, "getTemplateMeta");
    this.alterTemplateMetaFiles = /* @__PURE__ */ __name(async ({ files, metaDir }) => {
      const imports = [];
      const ext = ".spec.d.ts";
      files.forEach((file) => {
        if (file.path.endsWith(ext)) {
          const { base } = (0, import_path2.parse)(file.path);
          const [patternId, templateId] = base.split(".");
          const isFirst = templateId === this.id;
          const exportName = this.changeCase(`${patternId}Props`);
          const exportNameWithTemplateId = this.changeCase(
            `${patternId}-${templateId}Props`
          );
          imports.push(
            `export { ${isFirst ? exportName : `${exportName} as ${exportNameWithTemplateId}`} } from './${(0, import_path2.relative)(metaDir, file.path).replace(".d.ts", "")}';`
          );
        }
      });
      imports.push("");
      return [
        ...files,
        {
          contents: imports.join("\n"),
          encoding: "utf8",
          path: (0, import_path2.join)(metaDir, "react.d.ts")
        }
      ];
    }, "alterTemplateMetaFiles");
    this.language = "jsx";
    this.assets = [];
    this.demoWrapperPath = demoWrapperPath;
    this.disableReactStrictMode = disableReactStrictMode;
    this.creators = [createReactPattern];
  }
  async init(opt) {
    await super.init(opt);
    this.assets = await copyReactAssets(this.outputDir, this.publicPath);
    if (!await (0, import_file_utils3.exists)(this.demoWrapperPath)) {
      throw new Error(
        `Could not find demo wrapper at: "${this.demoWrapperPath}"`
      );
    }
  }
  changeCase(str) {
    return (0, import_utils3.pascalCase)(str);
  }
  createWebpackConfig() {
    const config = super.createWebpackConfig();
    config.externals = {
      react: "React",
      "react-dom": "ReactDOM"
    };
    return config;
  }
  getJsImports() {
    const imports = super.getJsImports();
    imports.push(
      {
        type: "extra",
        importInfo: {
          type: "default",
          path: this.demoWrapperPath,
          name: "DemoWrapper"
        }
      },
      {
        type: "extra",
        importInfo: {
          type: "default",
          path: (0, import_path2.join)(__dirname, "./error-catcher.js"),
          name: "ErrorCatcher"
        }
      }
    );
    return imports;
  }
  async prepClientRenderResults({
    usage,
    demoApp,
    imports: xImports,
    renderOptions: { pattern, template, demo }
  }) {
    const extraImportNames = this.getJsImports().flatMap(
      (imp) => imp.type === "extra" ? [imp.importInfo.name] : []
    );
    const { imports, isDeclaredVarsUnique, nameCollisions } = this.makeKsJsImportsUnique({ imports: xImports });
    if (!isDeclaredVarsUnique) {
      import_app2.log.error(`${nameCollisions.join(", ")} are declared multiple times`, {
        imports
      });
    }
    const importNames = [
      ...imports.map(({ importInfo: { name } }) => name),
      ...extraImportNames
    ];
    const patternsUsed = imports.flatMap((imp) => {
      if (imp.type === "pattern-template") {
        return [
          {
            patternId: imp.patternId,
            templateId: imp.templateId
          }
        ];
      }
      if (imp.type === "pattern-template-demo") {
        return [
          {
            patternId: imp.patternId,
            templateId: imp.templateId,
            demoId: imp.demoId
          }
        ];
      }
      return [];
    });
    const demoWrapperProps = {
      patternsUsed,
      pattern,
      template,
      demo
    };
    const demoWrapperCode = await getUsage({
      templateName: "DemoWrapper",
      props: demoWrapperProps,
      children: `<DemoApp />`
      // extraProps,
    });
    async function renderReact({
      patterns,
      theExtraImportNames,
      ksGlobal
    }) {
      if (!ksGlobal) {
        throw new Error('"window.knapsack" is null');
      }
      const components = await ksGlobal.getAllImports({
        patterns,
        extras: theExtraImportNames.map((name) => ({ name }))
      });
      return components;
    }
    __name(renderReact, "renderReact");
    let code = `

${renderReact.toString()}
${renderReact.name}({
  ksGlobal: window.knapsack,
  patterns: ${JSON.stringify(patternsUsed)},
  theExtraImportNames: ${JSON.stringify(extraImportNames)},
}).then((components) => {
  const { ${importNames.join(", ")} } = components;
  const root = document.getElementById('render-root');

  ${demoApp}

  const reactDomVersion = parseInt(ReactDOM.version.split('.')[0], 10);

  const ReactRendererResult = () => {
    if (reactDomVersion < 17 || ${this.disableReactStrictMode}){
      return (
        <ErrorCatcher>
          ${demoWrapperCode}
        </ErrorCatcher>
      )
    }

    return (
      <React.StrictMode>
        <ErrorCatcher>
          ${demoWrapperCode}
        </ErrorCatcher>
      </React.StrictMode>
    )
  };


  if (reactDomVersion > 17){
    ReactDOM.createRoot(root).render(
      <ReactRendererResult />
    )
  } else {
    ReactDOM.render(
      <ReactRendererResult />,
      root
    );
  }
}).catch((err) => {
  console.error(err);
  const root = document.getElementById('render-root');
  // Create a new <div> element to contain the error message
  const errorMsgDiv = document.createElement('div');
  // Insert the new <div> element before the existing element
  root.parentNode.insertBefore(errorMsgDiv, root);
  // add error message so users can see it
  errorMsgDiv.innerHTML = '<h1>Component Error</h1><p>' + err.message + '</p>';
});
    `;
    let codeHadError = false;
    let errorHtmlMsg = "";
    try {
      code = await this.babelCodeForBrowser({
        code
      });
    } catch (e) {
      codeHadError = true;
      console.log(code);
      console.log("---original code before babel error ^---");
      console.trace(e.message);
      code = `console.error(${JSON.stringify(e.message)});`;
      errorHtmlMsg = `<pre><code>${e.message}</code></pre>`;
    }
    if (!codeHadError) {
      try {
        code = await (0, import_file_utils3.formatCode)({
          contents: code,
          path: "x.tsx"
          // doing this to set format language
        });
      } catch (e) {
        codeHadError = true;
        console.log(code);
        console.log("---original code before prettier error ^---");
        console.trace(e.message);
        code = `console.error(${JSON.stringify(e.message)});`;
        errorHtmlMsg = `<pre><code>${e.message}</code></pre>`;
      }
    }
    const html = `
    ${this.assets.map((asset) => `<script src="${asset}"></script>`).join("\n")}

    ${this.createHtmlTagsForAssetPaths({
      assets: this.getWebpackAssetPaths(),
      // we need the scripts to finish adding methods to the global knapsack object synchronously before the client-side code runs that is in the <script> tag below
      scriptTagsAreAsync: false
    })}

    <div id="render-root" class="knapsack-pattern-direct-parent" data-dev-note="Knapsack React Template Wrapper"></div>
    <script type="application/javascript">${code}</script>
${errorHtmlMsg}

    `;
    return {
      ok: !codeHadError,
      html: await (0, import_file_utils3.formatCode)({
        contents: html,
        path: "x.html"
        // doing this to set format language
      }),
      usage,
      templateLanguage: this.language
    };
  }
  async render(opt) {
    if (_KnapsackReactRenderer.isTemplateDemo(opt.demo)) {
      const waits = [5, 10, 20, 50, 100, 1e3, 1e3];
      let templateDemoPath;
      let attempt = 0;
      while (true) {
        try {
          templateDemoPath = opt.patternManifest.getTemplateDemoAbsolutePath({
            patternId: opt.pattern.id,
            templateId: opt.template.id,
            demoId: opt.demo.id
          });
          break;
        } catch (e) {
          const waitTime = waits[attempt];
          if (!waitTime) {
            throw new Error(e);
          }
          attempt += 1;
          await (0, import_sleep_promise.default)(waitTime);
        }
      }
      const [templateFileContents, { usage, imports }] = await Promise.all([
        (0, import_file_utils3.readFile)(templateDemoPath),
        this.getUsageAndImports(opt)
      ]);
      const demoApp = await getDemoAppUsage({
        children: usage
      });
      const results = await this.prepClientRenderResults({
        usage: templateFileContents,
        demoApp,
        imports,
        renderOptions: opt
      });
      return results;
    }
    if (_KnapsackReactRenderer.isDataDemo(opt.demo)) {
      const { usage, imports } = await this.getUsageAndImports(opt);
      const { code: importCode } = this.createJsImportCodeBlock({
        imports
      });
      const [demoAppUsage, demoApp] = await Promise.all([
        getDemoAppUsage({
          children: usage,
          imports: importCode
        }),
        getDemoAppUsage({
          children: usage
        })
      ]);
      return this.prepClientRenderResults({
        demoApp,
        usage: demoAppUsage,
        imports,
        renderOptions: opt
      });
    }
  }
  async getUsageAndImports(opt) {
    const { pattern, template, patternManifest, demo } = opt;
    if ((demo == null ? void 0 : demo.type) && _KnapsackReactRenderer.isDataDemo(demo)) {
      const {
        data: { props, slots }
      } = demo;
      const importInfo = this.getJsImport({
        patternId: pattern.id,
        templateId: template.id
      });
      if (!importInfo) {
        throw new Error(
          `Could not find import for pattern-template: ${pattern.id}-${template.id}`
        );
      }
      const { type, name: templateName } = importInfo.importInfo;
      const importInfos = [importInfo];
      const children = [];
      const extraProps = [];
      if (slots) {
        const slotNames = Object.keys(slots);
        const slotUsages = await Promise.all(
          slotNames.map(async (slotName) => {
            const slotItems = slots[slotName];
            const usages = await Promise.all(
              slotItems.filter((slotItem) => {
                if (!(0, import_types2.isSlottedText)(slotItem)) {
                  if (!slotItem.patternId)
                    return false;
                  if (!slotItem.templateId)
                    return false;
                  if ((0, import_types2.isSlottedTemplateDemo)(slotItem) && !slotItem.demoId) {
                    return false;
                  }
                }
                return true;
              }).map(async (slotItem) => {
                if ((0, import_types2.isSlottedText)(slotItem)) {
                  if (slotItems.length === 1 && slotName !== "children") {
                    return `\`${slotItem.text}\``;
                  }
                  return slotItem.text;
                }
                const slotPattern = patternManifest.getPattern(
                  slotItem.patternId
                );
                const slotTemplate = slotPattern.templates.find(
                  (t) => t.id === slotItem.templateId
                );
                if ((0, import_types2.isSlottedTemplateReference)(slotItem)) {
                  const { usage: usage2, imports } = await this.getUsageAndImports({
                    pattern: slotPattern,
                    template: slotTemplate,
                    patternManifest
                  });
                  importInfos.push(...imports);
                  return usage2;
                }
                if ((0, import_types2.isSlottedTemplateDemo)(slotItem)) {
                  const { usage: usage2, imports } = await this.getUsageAndImports({
                    pattern: slotPattern,
                    template: slotTemplate,
                    demo: slotItem.demo || this.patterns.demosById[slotItem.demoId],
                    patternManifest
                  });
                  importInfos.push(...imports);
                  return usage2;
                }
                throw new Error(
                  `Unknown slot item: ${JSON.stringify(slotItem)}`
                );
              })
            );
            return {
              slotName,
              usages
            };
          })
        );
        slotUsages.forEach(({ slotName, usages }) => {
          usages.forEach((usage2) => {
            if (slotName === "children") {
              children.push(usage2);
            } else {
              extraProps.push({
                key: slotName,
                value: usage2
              });
            }
          });
        });
      }
      const usage = await getUsage({
        templateName,
        props,
        children: children.join("\n"),
        extraProps
      });
      return {
        usage,
        imports: importInfos
      };
    }
    if ((demo == null ? void 0 : demo.type) && _KnapsackReactRenderer.isTemplateDemo(demo)) {
      const importInfo = this.getJsImport({
        patternId: pattern.id,
        templateId: template.id,
        demoId: demo.id
      });
      if (!importInfo) {
        throw new Error(
          `Could not find import for pattern-template-demo: ${pattern.id}-${template.id}-${demo.id}`
        );
      }
      const { type, name: templateName } = importInfo.importInfo;
      const usage = await getUsage({ templateName });
      return {
        usage,
        imports: [importInfo]
      };
    }
    if (!demo) {
      const importInfo = this.getJsImport({
        patternId: pattern.id,
        templateId: template.id
      });
      if (!importInfo) {
        throw new Error(
          `Could not find import for pattern-template: ${pattern.id}-${template.id}`
        );
      }
      const { type, name: templateName } = importInfo.importInfo;
      return {
        /**
         * i.e. Given a React Component, `Button`, normally this would be `<Button>` with a demo, but since there is none this will just be a reference to it: `Button`
         * @see {KsSlotInfo['isTemplateReference']}
         * @see {SlottedTemplate}
         */
        usage: templateName,
        imports: [importInfo]
      };
    }
    throw new Error(
      `Unhandled demo type for ${pattern.id}-${template.id}: ${JSON.stringify(
        demo
      )}`
    );
  }
  async getUsage(opt) {
    const { usage } = await this.getUsageAndImports(opt);
    return usage;
  }
  async watch(opt) {
    await super.watch(opt);
    import_app2.knapsackEvents.onPatternTemplateChanged(() => {
      clearReactTypeScriptDocsCache();
    });
  }
  async getTemplateSuggestions({
    newPath
  }) {
    const { data: dataDir } = this.patterns.userConfig;
    const { allTemplateDemos, allTemplates } = this.getMyTemplates();
    const usedSuggestions = [
      ...allTemplateDemos,
      ...allTemplates
    ].map(({ path: path2, alias: alias2 }) => {
      return {
        path: path2,
        alias: alias2 || "default"
      };
    });
    const allPaths = [
      .../* @__PURE__ */ new Set([newPath, ...usedSuggestions.map(({ path: path2 }) => path2)])
    ];
    const {
      resolve: { alias }
    } = this.createWebpackConfig();
    const aliasConfig = {};
    if ((0, import_utils3.isObject)(alias)) {
      Object.entries(alias).forEach(([key, value]) => {
        if (typeof value === "string") {
          aliasConfig[key] = value;
        }
      });
    }
    const allSuggestions = await Promise.all(
      allPaths.map(async (path2) => {
        if (!path2)
          return [];
        try {
          const { exports, errorMsg } = await (0, import_file_utils3.getJsExportNames)({
            path: path2,
            resolveFromDir: dataDir,
            alias: aliasConfig
          });
          if (errorMsg) {
            throw new Error(errorMsg);
          }
          return exports.filter((e) => e === "default" || (0, import_utils3.isFirstLetterCapital)(e)).map((name) => ({
            alias: name,
            path: path2
          }));
        } catch (e) {
          import_app2.log.verbose(
            `Error getting import names for ${path2}: ${e.message}`,
            null,
            this.logPrefix
          );
          return [];
        }
      })
    ).then((results) => {
      return results.flat();
    });
    const suggestions = allSuggestions.filter((s) => {
      return !usedSuggestions.find(
        (us) => us.alias === s.alias && us.path === s.path
      );
    });
    return {
      suggestions
    };
  }
};
__name(_KnapsackReactRenderer, "KnapsackReactRenderer");
var KnapsackReactRenderer = _KnapsackReactRenderer;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  KnapsackReactRenderer
});
//# sourceMappingURL=index.js.map